var message = "";
message += "Left-Click  : Place vertices\n"
message += "Right-Click : Clear vertices\n"

var verts = ds_list_size(polygon) / 2;

//  Draw Polygon
if (verts >= 3) 
{
    if (!surface_exists(surf)) 
    {
        surf = surface_create(room_width, room_height);
    }

    if (surface_exists(surf)) 
    {
        //  A filled concave polygon can be easily
        //  drawn with a triangle fan if an XOR-like
        //  blend mode is used. Wherever the polygon
        //  crosses itself, its opacity will be toggled.
        //  Because the display buffer is always opaque,
        //  a transparent surface is used to manage the
        //  effect. Only one polygon at a time can be
        //  drawn this way. Non-simple polygons will
        //  retain holes where they self-intersect.
        
        surface_set_target(surf);
        draw_clear_alpha(c_black, 0.0);
        
        gpu_set_blendmode_ext(bm_inv_dest_alpha, bm_zero);
        draw_set_color(c_orange);
        draw_set_alpha(1.0);
        
        draw_primitive_begin(pr_trianglefan);
        for (var i=0; i<verts; i++) {
            var vertX = polygon[| 2*i];
            var vertY = polygon[| 2*i+1];
            draw_vertex(vertX, vertY);
        }
        draw_primitive_end();
        
        gpu_set_blendmode(bm_normal);
        
        surface_reset_target();
        
        draw_surface(surf, 0, 0);
    }
    else
    {
        message += "\nSURFACE ERROR\n";
    }
}

//  Draw Vertices
draw_set_color(c_white);
draw_set_alpha(1.0);
for (var i=0; i<verts; i++) 
{
    var vertX = polygon[| 2*i];
    var vertY = polygon[| 2*i+1];
    draw_circle(vertX, vertY, 3, false);
}

draw_set_font(font0);
draw_text(16, 16, message);